--------------------------------------------------------------------------------
-- NOM DU CSU (spécification)       : Chrono.ads
-- AUTEUR DU CSU                    : P. Pignard
-- VERSION DU CSU                   : 2.0b
-- DATE DE LA DERNIERE MISE A JOUR  : 10 février 2001
-- ROLE DU CSU                      : Chronométrage.
--
--
-- FONCTIONS EXPORTEES DU CSU       : Lance, Stoppe, Valeur.
--
--
-- FONCTIONS LOCALES DU CSU         :
--
--
-- NOTES                            :
--
--
--------------------------------------------------------------------------------
with Ada.Calendar; use Ada.Calendar;

package body Chrono is

  ValeurInitiale : Natural := 0;
  
  -- Lance le compteur horaire.
  procedure Lance is
  begin
    ValeurInitiale := Natural(Seconds(Clock) * 1000.0);
  end Lance;
  
  -- Stoppe le compteur horaire.
  procedure Stoppe is
  begin
    null;
  end;

  -- Renvoie le compteur horaire interne en milisecondes.
  function Valeur return Natural is
  begin
    return Natural(Seconds(Clock) * 1000.0) - ValeurInitiale;
  end Valeur;

end Chrono;